var wps_restore = '';
var wps_compress = '';
var wps_bulk_running = false;
//
var wps_compress_objects = [];
var wps_restore_objects = [];

jQuery(document).ready(function ($) {


    /**
     * Heartbeat for fixing stuck images
     */
    function wps_ic_fixing() {
        $.post(ajaxurl, {action: 'wps_ic_fixing'}, function (response) {
            if (response.success) {
                // Rerun bulk
                wps_ic_fixing();

                // Output Image info
                jQuery('div#wp-ic-image-' + response.data.attachment_id).html(response.data.info);

                // Setup new actions
                jQuery('div#wp-ic-image-actions-' + response.data.attachment_id).html(response.data.actions);

                // Update restore button path
                jQuery('input[name="wps_ic_restore_' + response.data.attachment_id + '"]').val(response.data.restore_path);

                // Hide Loading
                jQuery('#wp-ic-image-actions-' + response.data.attachment_id).show();

                jQuery('#wp-ic-image-loading-' + response.data.attachment_id).hide();
            }
        });
    }
    // Initial run fixing
    wps_ic_fixing();


    /**
     * Tooltip
     */
    $('.wps-ic-action-button').live({
        mouseenter: function () {
            var button = $(this);
            var text = $(button).attr('title');

            $(button).append('<div class="wps-ic-action-tooltip"><p>' + text + '</p></div>');

            var element = $('.wps-ic-action-tooltip', button);
            var width = $(element).width();
            $(element).css('left', '-' + ((width / 2) - 20) + 'px');


        },
        mouseleave: function () {
            var button = $(this);
            var text = $(button).attr('title');

            $('.wps-ic-action-tooltip', button).remove();
        }
    });


    /**
     * Action Disabled
     */
    $('.wps-ic-compress-queue-clear').live('click', function (e) {
        e.preventDefault();

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_clear_queue'}, function (response) {

        });
    });


    /**
     * Action Disabled
     */
    $('.wps-ic-action-disabled').live('click', function (e) {
        e.preventDefault();
        alert('This action has been disabled!');
    });


    /**
     * Compare Images
     */
    $('.wps-ic-compare-single').live('click', function (e) {
        e.preventDefault();

        var link = $(this);
        var object = $(link).attr('href');

        var original = $(link).data('original');
        var compressed = $(link).data('compressed');

        var parent = $(this).parents('.wp-ic-image-info');
        var outparent = $(parent).parent();
        var loading = $('.wps-ic-image-loading', outparent);

        $(object).html('<div class="wps-ic-popup-loading"><img src="' + wps_ic.uri + 'assets/images/spinner.svg" /><h1>We are processing your request...</h1></div>');
        $.featherlight($(object), {});

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compare', original: original, compressed: compressed}, function (response) {
            $('.featherlight-inner', '.featherlight').html(response.data);
        });

        //$(".twentytwenty-container").twentytwenty({default_offset_pct: 0.7});
    });


    /**
     * Compress Image Button - Single!!
     */
    $('.wps-ic-compress-single').live('click', function (e) {
        e.preventDefault();

        if (!is_api_online()) {
            return false;
        }

        wps_compress = 'true';
        trigger_speed = 1500;

        var button = $(this);
        var filename = $(this).data('filename');
        var attachment_id = $(this).data('image_id');
        var file = $(this).data('image');

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        $.ajaxSetup({async: true, cache: false});

        wps_compress_objects.push(attachment_id);

        $.post(ajaxurl, {action: 'wps_ic_compress_single', attachment_id: attachment_id, attachments:wps_compress_objects}, function (response) {

            if (response.success == true) {
                wps_ic_bulk_heartbeat();
                trigger_speed = 5000;
            }
        });

        return false;

    });


    /**
     * Restore Image Button - Single!!
     */
    $('.wps-ic-restore-single').live('click', function (e) {
        e.preventDefault();

        wps_restore = 'true';
        trigger_speed = 1500;

        var button = $(this);
        var attachment_id = $(this).data('image_id');
        var select = $('input[name="wps_ic_restore_' + attachment_id + '"]').val();

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        wps_restore_objects.push(attachment_id);

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore', attachment_id: attachment_id, file: select, attachments:wps_restore_objects}, function (response) {

            wps_ic_bulk_heartbeat();
            if (response.success == true) {
                trigger_speed = 5000;
                wps_compress = '';
            }

        });

    });


    /**
     * Compress Image Button - Bulk!!
     */
    var bulk_stop = false;
    var compressing = false;
    $('.wps-ic-compress-bulk').on('click', function (e) {

        var button = $(this);
        var results_container = $('.wps-ic-bulk-progress');
        var title = $('.wps-ic-media-bulk');

        $(results_container).fadeIn();

        bulk_stop = false;
        compressing = true;

        //wps_bulk_messages();

        var message_list = $('ul li', '.wps-ic-bulk-prep');

        $('h1.wps-ic-compress-not-started', title).hide();
        $('h1.wps-ic-compress-started', title).show();

        $(button).hide();
        $('a.wps-ic-bulk-stop').show();

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compress_bulk_prep_background'}, function (response) {
            if (response.success) {

                //var bulk_data = response.data;
                //window.location.href = bulk_data;
                //wps_ic_bulk_compress();

                var bulk_data = response.data;
                wps_ic_background_compress();


            } else {
                alert('Ooops! This is embarrassing... :(');
            }
        });


    });


    /**
     * Compress Bulk - Stop
     */
    $('.wps-ic-bulk-stop').live('click', function(e){
        e.preventDefault();

        var button = $(this);
        var action = $(this).data('action');
        var results_container = $('.wps-ic-bulk-progress');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        $(button).html('Stopping...');

        $('h1.wps-ic-compress-not-started', title).show();
        $('h1.wps-ic-compress-started', title).hide();

        bulk_stop = true;

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compress_bulk_stop'}, function (response) {
            if (response.success) {
                compressing = false;
                clearInterval(messageInterval);
                $('div', results_container).hide();
                $(results_container).append(response.data);
                //$(info).html(response.data);
                //$(button).html('Continue').removeClass('wps-ic-bulk-stop');
                $(button).hide();
                $('button.wps-ic-compress-bulk').show();
                window.location.reload();
            } else {
                alert('Ooops! This is embarrassing... :(');
            }
        });

        return false;
    });


    /**
     * Exchange messages
     */
    var messageInterval;

    function wps_bulk_messages() {
        var message_list = $('ul li', '.wps-ic-bulk-prep');
        var index = 0;

        // setup a function to show the current one and increase the index
        var doNext = function () {
            var element = $(message_list).eq(index);

            if ($(element).hasClass('init') || $(element).hasClass('one-time')) {
                index++;
            }

            doThis(index);
            // increment the index - if it is beyond the number of li's - reset it to 0
            if (++index >= $(message_list).length) index = 0;
        };

        // call it once as we load
        doNext();
        // set it up to be called every 5000 ms
        messageInterval = setInterval(doNext, 2500);
    }

    function doThis(index) {
        var message_list = $('ul li', '.wps-ic-bulk-prep');
        var element = $(message_list).eq(index);

        $('ul li', '.wps-ic-bulk-prep').hide();
        $(element).show();
    }


    $('.wps-ic-pro-exclude,.wps-ic-pro-include').live('click', function (e) {
        e.preventDefault();

        var button = $(this);
        var attachment_id = $(button).data('attachment_id');

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        $.post(ajaxurl, {action: 'wps_ic_pro_exclude', attachment_id: attachment_id}, function (response) {

            // Image data
            $('div#wp-ic-image-' + attachment_id).html(response.data.info);

            // Setup new actions
            $('div#wp-ic-image-actions-' + attachment_id).html(response.data.actions);

            $(parent).show();
            $(loading).hide();
        });

    });


    /**
     * Compress Background Function
     */
    function wps_ic_background_compress() {
        var button = $('.wps-ic-compress-bulk');
        var results_container = $('.wps-ic-bulk-progress');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        if (bulk_stop == true) {
            wps_ic_bulk_running = false;
            return false;
        }

        wps_ic_bulk_running = true;

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compress_background'}, function (response) {
            if (response.success) {

                var message_list = $('.wps-ic-bulk-prep');
                $('li:first-child', message_list).hide();
                $('li:last-child', message_list).show();

                updateProgressBar(response.data.status);
                updateStatsBox(response.data.stats);

                if ($(prepare).is(':visible')) {

                    $(info).fadeOut(function () {
                        $(info).html(response.data.html).fadeIn(function () {
                            wps_ic_background_compress();
                        });
                    });

                } else {
                    $(info).fadeOut(function () {
                        $(info).html(response.data.html);
                    }).fadeIn();
                    wps_ic_background_compress();
                }

            } else {
                // Nothing
                $(button).html('Compress').removeAttr('disabled');
                clearInterval(messageInterval);

                wps_ic_bulk_running = false;

                // Finished
                $('h1', prepare).html('Image Optimization Complete');

                // Update progress bar
                var obj = JSON.parse('{"total_files":"1","processed_files":"1"}');
                updateProgressBar(obj);

                //
                var container = $('#wps-ic-media-bulk-instructions');
                $('.wps-ic-bulk-not-started', container).hide(function(){
                    $('.wps-ic-bulk-complete', container).fadeIn(500);
                });

                $('h1.wps-ic-compress-not-started', title).show();
                $('h1.wps-ic-compress-started', title).hide();

                // Total Saved
                $.post(ajaxurl, {action: 'wps_ic_compress_total_saved'}, function (response) {

                    // Social Saved
                    var twitter = $('a', '.wps-ic-twitter').attr('href');
                    twitter = twitter.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-twitter').attr('href', twitter);

                    var linkedin = $('a', '.wps-ic-linkedin').attr('href');
                    linkedin = linkedin.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-linkedin').attr('href', linkedin);

                    var mail = $('a', '.wps-ic-mail').attr('href');
                    mail = mail.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-mail').attr('href', mail);

                    $(info).html(response.data.output).fadeIn(function () {
                    });
                });
            }
        });
    }

    /**
     * Compress Bulk Function
     */
    function wps_ic_bulk_compress() {
        var button = $('.wps-ic-compress-bulk');
        var results_container = $('.wps-ic-bulk-progress');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        if (bulk_stop == true) {
            return false;
        }

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compress_bulk'}, function (response) {
            if (response.success) {


                if (typeof response.data.status !== undefined) {

                    updateProgressBar(response.data.status);
                    updateStatsBox(response.data.stats);

                    if ($(prepare).is(':visible')) {

                        $(info).fadeOut(function () {
                            $(info).html(response.data.html).fadeIn(function () {
                                wps_ic_bulk_compress();
                            });
                        });

                    } else {
                        $(info).fadeOut(function () {
                            $(info).html(response.data.html);
                        }).fadeIn();
                        wps_ic_bulk_compress();
                    }

                }

            } else {
                // Nothing
                $(button).html('Compress').removeAttr('disabled');
                clearInterval(messageInterval);

                // Finished
                $('h1', prepare).html('Image Optimization Complete');

                // Update progress bar
                var obj = JSON.parse('{"total_files":"1","processed_files":"1"}');
                console.log(obj);
                updateProgressBar(obj);

                $('h1.wps-ic-compress-not-started', title).show();
                $('h1.wps-ic-compress-started', title).hide();

                // Total Saved
                $.post(ajaxurl, {action: 'wps_ic_compress_total_saved'}, function (response) {

                    // Social Saved
                    var twitter = $('a', '.wps-ic-twitter').attr('href');
                    twitter = twitter.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-twitter').attr('href', twitter);

                    var linkedin = $('a', '.wps-ic-linkedin').attr('href');
                    linkedin = linkedin.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-linkedin').attr('href', linkedin);

                    var mail = $('a', '.wps-ic-mail').attr('href');
                    mail = mail.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-mail').attr('href', mail);

                    $(info).html(response.data.output).fadeIn(function () {
                    });
                });
            }
        });
    }


    /**
     * Update Stats Box
     */
    function updateStatsBox(data) {
        var Box = $('.wps-ic-bulk-savings');
        var Inner = $('.inner', Box);

        $(Inner).html(data);
    }


    /**
     * Update progress bar
     */
    function updateProgressBar(data) {
        var progressBar = $('.wps-ic-bulk-progress-bar');
        var progressBarInner = $('.wps-ic-bulk-progress-bar-inner');
        var progressBarSpan = $('.wps-ic-bulk-progress-bar-inner>span');

        var total = data.total_files;
        var processed = data.processed_files;
        var status = parseInt(processed) / parseInt(total);
        status = status * 100;
        status = Math.round(status).toString();

        if (status >= 48) {
            $(progressBarSpan).addClass('white');
        }

        $(progressBarSpan).html(status + '%');
        $(progressBarInner).css('width', status + '%');

    }

});