<?php


/**
 * Class - Bulk
 */
class wps_ic_bulk extends wps_ic {

  public $options;
  public $api_url;


  public function __construct() {
    if (is_admin()) {
      $this->api_url = 'https://api.wpcompress.com/';

      // Fetch thumbnails
      $this->add_ajax('wps_ic_bulk_thumbnails_background');
    }
  }


  public function add_ajax($hook) {
    add_action('wp_ajax_' . $hook, array($this, $hook));
  }


  public function wps_ic_bulk_thumbnails_background() {
    global $wps_ic;

    $uploaddir  = wp_upload_dir();
    $uploadfile = $uploaddir['path'] . '/';
    $bulked_thumbnails = get_option(WPS_IC_BULK_BACKGROUND_THUMBNAILS);

    // How many items to process per call?
    $per_call = 5;
    $processed = 0;

    if ($bulked_thumbnails && count($bulked_thumbnails) > 0) {
      foreach ($bulked_thumbnails as $attachment_ID => $item) {

        $check_thumbnails = wp_remote_get($this->api_url . '?fetch_thumbnails=true&api_key=' . $wps_ic::$api_key . '&attachment_ID=' . $attachment_ID, array('timeout' => 5));


        if (wp_remote_retrieve_response_code($check_thumbnails) == 200) {

          $body = wp_remote_retrieve_body($check_thumbnails);
          $body = json_decode($body, true);

          if ($body['success'] == true) {

            $data = $body['data'][ $attachment_ID ];

            if (is_array($data)) {
              foreach ($data as $thumb_size => $thumb_url) {
                $thumbnail_meta = wp_get_attachment_metadata($attachment_ID);

                if ($thumbnail_meta) {
                  $sizes                  = $thumbnail_meta['sizes'];
                  $current_size           = $sizes[ $thumb_size ];
                  $current_thumbnail      = $current_size['file'];
                  $currnet_thumbnail_path = $uploadfile . $current_thumbnail;

                  if (file_exists($currnet_thumbnail_path)) {
                    unlink($currnet_thumbnail_path);
                  }

                  $temp_file = download_url($thumb_url, 30);
                  copy($temp_file, $currnet_thumbnail_path);

                  // Remove from bulk
                  unset($bulked_thumbnails[$attachment_ID]);
                  update_option(WPS_IC_BULK_BACKGROUND_THUMBNAILS, $bulked_thumbnails);
                }
              }
            }

            $remove_thumanils = wp_remote_get($this->api_url . '?fetch_thumbnails=true&api_key=' . $wps_ic::$api_key . '&attachment_ID=' . $attachment_ID . '&remove=true', array('timeout' => 5));

          } else {
            // Not ready yet
          }
        }

        $processed++;

        // Have we reached our limit?
        if ($processed >= $per_call) {
          wp_send_json_success();
        }
      }
    }

    wp_send_json_error();
  }


}