<?php


/**
 * Class - Cron
 */
class wps_ic_cron {
	
	public function __construct() {
    $this->api_url = 'https://api.wpcompress.com/';
		add_action('wps_ic_single_thumbnail', array($this, 'cron_regenerate_single_thumbnail'), 10, 1);

		// Cron for Bulk
		add_action('wps_ic_cron_compress', array($this, 'cron_compress_bulk'));
	}


	public function cron_compress_bulk() {
    global $wps_ic;

    if (!defined('ABSPATH')) {
      /** Set up WordPress environment */
      require_once(dirname(__FILE__) . '/wp-load.php');
    }

    if (!function_exists('wp_generate_attachment_metadata')) {
      require_once ABSPATH . 'wp-admin/includes/image.php';
    }

    $done = get_option(WPS_IC_BULK_DONE);
    $files = get_option(WPS_IC_BULK);

    mail('hrvoje.krbavac@gmail.com', 'Cron BULK Fire2', print_r($files, true));

    $attachments = get_posts(array('post_type' => 'attachment', 'posts_per_page' => '-1', 'post_status' => 'any'));

    if ($attachments) {
      foreach ($attachments as $attachment) {
        $files[$attachment->ID] = $attachment->ID;
      }
    }

    if ($files) {
      $wps_ic->log->write('Cron Start', print_r($files, true));
      foreach ($files as $attach_id => $value) {
        //sleep(5);
        $wps_ic->log->write('Cron', 'In loop start ' . $attach_id);
        $wps_ic->compress->single_cron(array('attachment_id' => $attach_id), 'none');

        // Get bulked files for compress background
        $bulk_compress_background = get_option(WPS_IC_BULK);

        // Remove from Bulk Compress Background
        unset($bulk_compress_background[$attach_id]);
        update_option(WPS_IC_BULK, $bulk_compress_background);

        // Mark file as done
        $wps_ic->log->write('Cron', 'In loop End ' . $attach_id);
/*
        $done[] = $attach_id;
        unset($files[$attach_id]);
        delete_post_meta($attach_id, 'wps_ic_in_bulk');
        delete_post_meta($attach_id, 'wps_ic_compressing');*/
      }

      $wps_ic->log->write('Cron', 'Exit Loop');
/*
      update_option(WPS_IC_BULK, $files);
      update_option(WPS_IC_BULK_DONE, $done);*/
    }
  }
	
	
	public function cron_fetch_thumbnails() {
		global $wps_ic;

    $wps_ic->log->write('CRON', 'Cron Started');
		
		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}
		
		$compress_queue = get_option(WPS_IC_CRON_QUEUE);
		
		$uploaddir = wp_upload_dir();
		$uploadfile = $uploaddir['path'] . '/';
    $wps_ic->log->write('CRON Queue', print_r($compress_queue, true));
		if ($compress_queue) {
			foreach ($compress_queue as $attach_id => $file) {
				
				$check_thumbnails = wp_remote_get($this->api_url . '?fetch_thumbnails=true&api_key=' . $wps_ic::$api_key . '&attachment_ID=' . $attach_id, array('timeout' => 5));

				if (wp_remote_retrieve_response_code($check_thumbnails) == 200) {
					$body = wp_remote_retrieve_body($check_thumbnails);

          $wps_ic->log->write('CRON', print_r($body, true));

					$body = json_decode($body, true);

					
					if ($body['success'] == true) {
						
						$data = $body['data'][$attach_id];
						
						if (is_array($data)) {
							foreach ($data as $thumb_size => $thumb_url) {
								$thumbnail_meta = wp_get_attachment_metadata($attach_id);
								
								if ($thumbnail_meta) {
									$sizes = $thumbnail_meta['sizes'];
									$current_size = $sizes[$thumb_size];
									$current_thumbnail = $current_size['file'];
									$currnet_thumbnail_path = $uploadfile . $current_thumbnail;
									
									if (file_exists($currnet_thumbnail_path)) {
										unlink($currnet_thumbnail_path);
									}
									
									$temp_file = download_url($thumb_url, 30);
									copy($temp_file, $currnet_thumbnail_path);
									
								}
								
							}
						}
						
						$remove_thumanils = wp_remote_get($this->api_url . '?fetch_thumbnails=true&api_key=' . $wps_ic::$api_key . '&attachment_ID=' . $attach_id . '&remove=true', array('timeout' => 5));
						
						unset($compress_queue[$attach_id]);
						update_option(WPS_IC_CRON_QUEUE, $compress_queue);
						wp_send_json_success();
						
					} else {
						// Not ready yet
					}
					
				} else {
					wp_send_json_error('Still processing.');
				}
				
			}
		}
		
		wp_send_json_error('Nothing to report.');
	}
	
	
	public function cron_regenerate_single_thumbnail($attach_id = '') {

    mail('hrvoje.krbavac@gmail.com', 'Regen Thumbnail', 'regend dev ' . $attach_id);

		if (empty($attach_id)) {
			return;
		}
		
		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}

    mail('hrvoje.krbavac@gmail.com', 'Regen Thumbnail', 'regend dev ' . print_r($attach_id, true));

    $uploadfile = get_attached_file($attach_id);
		$attach_data = wp_generate_attachment_metadata($attach_id, $uploadfile);
		wp_update_attachment_metadata($attach_id, $attach_data);
	}
	
	
	public function cron_compress_single_image() {
		global $wps_ic;
		
		$wps_ic = new wps_ic();

		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}
		
		mail('hrvoje.krbavac@gmail.com', 'cron fire', 'cron na dev');
		
		$cron_queue = get_option(WPS_IC_CRON_QUEUE);
		
		if ($cron_queue) {
			foreach ($cron_queue as $key => $attach_id) {
				
				$src = wp_get_attachment_image_src($attach_id, 'full');
				if (!empty($src[0])) {
					$wps_ic->compress->single_full(array('attachment_id' => $attach_id), 'none');
					unset($cron_queue[$attach_id]);
					delete_post_meta($attach_id, 'wps_ic_compressing');
				}
			}
			

			update_option(WPS_IC_CRON_QUEUE, $cron_queue);
		}
	}
	
	
	public function cron_regenerate_thumbnails() {
		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}
		
		$cron_queue = get_option(WPS_IC_CRON_QUEUE);
		if ($cron_queue) {
			foreach ($cron_queue as $attach_id => $uploadfile) {
				$attach_data = wp_generate_attachment_metadata($attach_id, $uploadfile);
				wp_update_attachment_metadata($attach_id, $attach_data);
				
				unset($cron_queue[$attach_id]);
			}
			
			update_option(WPS_IC_CRON_QUEUE, $cron_queue);
		}
	}
	
	
}