<?php


/**
 * Class - Database
 */
class wps_ic_database extends wps_ic {
	
	public $database;
	
	
	public function __construct() {
		return $this;
	}


	public function delete_tables() {
    global $wpdb;

    $sql1 = "DROP TABLE `" . $wpdb->prefix . "ic_queue`;";
    $wpdb->query($sql1);

    $sql2 = "DROP TABLE `" . $wpdb->prefix . "ic_backups`;";
    $wpdb->query($sql2);

    $sql3 = "DROP TABLE `" . $wpdb->prefix . "ic_compressed`;";
    $wpdb->query($sql3);
  }
	
	
	public function create_tables() {
		$this->create_backup_table();
		$this->create_compressed_table();
		$this->create_compress_table();
	}
	
	
	public function create_compress_table() {
		
		global $wpdb;
		
		$charset_collate = $wpdb->get_charset_collate();
		
		$sql = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "ic_queue` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `attachment_ID` int(11) NOT NULL,
  `type` varchar(16) COLLATE utf8mb4_unicode_ci NOT NULL,
  `status` tinyint(4) NOT NULL,
  `old_metadata` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `new_metadata` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `created` datetime NOT NULL, PRIMARY KEY (`ID`),UNIQUE KEY `attachment_ID` (`attachment_ID`))" . $charset_collate . ";";

		/*
		 * ALTER TABLE `wpib_ic_queue`
  ADD PRIMARY KEY (`ID`),
  ADD UNIQUE KEY `attachment_ID` (`attachment_ID`);
		 */

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);

	}


	public function create_backup_table() {

		global $wpdb;

		$charset_collate = $wpdb->get_charset_collate();

		$sql = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "ic_backups` (`ID` int(11) NOT NULL AUTO_INCREMENT, `attachment_ID` int(11) NOT NULL DEFAULT '0', `path` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL, `url` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL, `filename` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL, `size` float NOT NULL, `created` datetime NOT NULL, PRIMARY KEY  (ID),UNIQUE KEY `attachment_filename` (`attachment_ID`,`filename`))$charset_collate;";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);

	}
	
	
	public function create_compressed_table() {
		
		global $wpdb;
		
		$charset_collate = $wpdb->get_charset_collate();
		
		$sql = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "ic_compressed` (`ID` int(11) NOT NULL AUTO_INCREMENT, `created` datetime NOT NULL, `attachment_ID` int(11) NOT NULL, `saved` float NOT NULL, `percent_saved` float NOT NULL, PRIMARY KEY  (ID),UNIQUE KEY `attachment_ID` (`attachment_ID`)) $charset_collate;";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);

	}
	
	
}