<?php


/**
 * Class - Ajax
 */
class wps_ic_demo_ajax extends wps_ic {

  public $options;
  public $api_url;


  public function __construct() {
    if (is_admin()) {

      $this->api_url = 'https://api.wpcompress.com/';

      $this->options = new wps_ic_options();

      // Load sample image for intro
      $this->add_ajax('wps_ic_sample');
      $this->add_ajax('wps_ic_compress_single_demo');
      $this->add_ajax('wps_ic_restore_single_demo');
      $this->add_ajax('wps_ic_dialog_bulk');

    }
  }


  public function add_ajax($hook) {
    add_action('wp_ajax_' . $hook, array($this, $hook));
  }


  /***
   * Load More - Bulk
   */
  public function wps_ic_dialog_bulk() {
    $info = sanitize_text_field($_POST['info']);

    // Loading
    $html = '';
    $html .= '<div class="wps-ic-image-loading" id="wps-ic-sample-image-loading" style="display:none;">';
    $html .= '<img src="' . WPS_IC_URI . 'assets/images/spinner.svg" />';
    $html .= '</div>';

    sleep(1);

    if ($info == 'bulk') {

      $attachments = get_posts(array('post_type' => 'attachment', 'posts_per_page' => -1));
      $count = count($attachments);

      $html .= '<div class="wps-ic-sample-data" id="wps-ic-sample-data">';

      $html .= '<h3>Bulk Compression</h3>';
      $html .= '<p>Most websites will have more than one image. You currently have ' . $count . '. You can compress all of your images in one click by visiting Bulk Compress under Media.</p>';

      $html .= '<img src="' . WPS_IC_URI . '/assets/intro/assets/bulk.png" style="max-width:170px;" />';

      $html .= '<p class="smaller-p">We support background processing so you can work with no interruptions.</p>';

      $html .= '<div class="clearfix"></div>';

      $html .= '<a href="#" class="wps-ic-dialog-btn wps-ic-dialog-more-bulk" data-info="exclude">Got it, Thanks!</a>';
      $html .= '</div>';
    } else if ($info == 'exclude') {

      $html .= '<div class="wps-ic-sample-data" id="wps-ic-sample-data">';

      $html .= '<h3>Excluding Images</h3>';
      $html .= '<p>If for any reason you want to exclude an image from bulk<br/>compression, you can do so using the drop down in List mode of the Media Library.</p>';

      $html .= '<img src="' . WPS_IC_URI . '/assets/intro/assets/exclude_dd.png" style="vertical-align:top;" />';

      $html .= '<div class="clearfix"></div>';
      $html .= '<a href="#" class="wps-ic-dialog-btn wps-ic-dialog-more-bulk" data-info="all-set">Got it, Thanks!</a>';
      $html .= '</div>';

    } else if ($info == 'all-set') {
      $html .= '<div class="wps-ic-sample-data" id="wps-ic-sample-data">';

      $html .= '<img src="' . WPS_IC_URI . '/assets/images/logo-bulk.png" />';
      $html .= '<br/>';
      $html .= '<br/>';
      $html .= '<h3>You\'re all set!</h3>';

      $html .= '<p>To securely connect with our API and the Compression Cloud, you’ll need an API Key. This allows us to verify that your data is safe and we’re sending the optimized images to the right place.</p>';

      $html .= '</div>';
    }


    wp_send_json_success(array('html' => $html));
  }

  /**
   * Sample image Restore
   */
  public function wps_ic_restore_single_demo() {
    global $wps_ic;

    sleep(2);

    // Uncompressed
    $uncompress_sample_dir = WPS_IC_DIR . 'assets/intro/assets/intro_b_noncompressed.jpg';
    $uncompress_sample_uri = WPS_IC_URI . 'assets/intro/assets/intro_b_noncompressed.jpg';

    $html = '';

    // Loading
    $html .= '<div class="wps-ic-image-loading" id="wps-ic-sample-image-loading" style="display:none;">';
    $html .= '<img src="' . WPS_IC_URI . 'assets/images/spinner.svg" />';
    $html .= '<h5>Loading next step...</h5>';
    $html .= '</div>';

    $html .= '<div class="wps-ic-sample-data" id="wps-ic-sample-data">';

    $html .= '<h3>Restore Complete</h3>';
    $html .= '<p>As long as you keep “Backup Original Images” toggled, you can restore your images back to the original at any point and recompress on different settings.</p>';

    // Image
    $html .= '<img src="' . $uncompress_sample_uri . '" id="wps-ic-sample-image" />';

    $html .= '<div class="clearfix"></div>';
    $html .= '<a href="#" class="wps-ic-dialog-btn wps-ic-dialog-more-bulk" data-info="bulk">Got it, Thanks!</a>';

    // wps_ic_sample_data
    $html .= '</div>';


    wp_send_json_error(array('html' => $html));
  }


  /**
   * Sample Image Compress
   */
  public function wps_ic_compress_single_demo() {
    global $wps_ic;

    $logo_compressed   = WPS_IC_URI . 'assets/images/compressed.png';
    $logo_uncompressed = WPS_IC_URI . 'assets/images/not-compressed.png';
    $logo_excluded     = WPS_IC_URI . 'assets/images/excluded.png';

    sleep(2);

    $html = '';

    // Loading
    $html .= '<div class="wps-ic-image-loading" id="wps-ic-sample-image-loading" style="display:none;">';
    $html .= '<img src="' . WPS_IC_URI . 'assets/images/spinner.svg" />';
    $html .= '<h5>Sit tight, we\'re restoring the image...</h5>';
    $html .= '</div>';

    $html .= '<div class="wps-ic-sample-data" id="wps-ic-sample-data">';
    $html .= '<h3>Great job!</h3>';
    $html .= '<p>You\'ve compressed your first image. That was easy!<br/>';
    $html .= 'Now let\'s try restoring it to the original image.</p>';


    // Uncompressed
    $uncompress_sample_dir = WPS_IC_DIR . 'assets/intro/assets/intro_b_noncompressed.jpg';
    $uncompress_sample_uri = WPS_IC_URI . 'assets/intro/assets/intro_b_noncompressed.jpg';

    $compress_data['old']['size'] = filesize($uncompress_sample_dir);
    $compress_data['old']['dimension'] = getimagesize($uncompress_sample_dir);

    // Compressed
    $compress_sample_dir = WPS_IC_DIR . 'assets/intro/assets/intro_b_compressed.jpg';
    $compress_sample_uri = WPS_IC_URI . 'assets/intro/assets/intro_b_compressed.jpg';

    $compress_data['new']['size'] = filesize($compress_sample_dir);
    $compress_data['new']['dimension'] = getimagesize($compress_sample_dir);

    // Saved
    $saved_bytes = ($compress_data['old']['size'] - $compress_data['new']['size']);
    $current_save = (($compress_data['new']['size'] - $compress_data['old']['size']) / $compress_data['old']['size']);
    $current_save = $current_save * 100;
    $current_save = absint($current_save);
    $current_save = round($current_save, 0);

    // Not compressed
    $dimensions             = getimagesize($compress_sample_dir);
    $file_name              = basename($compress_sample_uri);

    #$html .= '<div class="wps-ic-sample-data" id="wps-ic-sample-data">';

    // Just optimized row
    $html .= '<div class="just-optimized-row">';

    $html .= '<div class="third">';
    $html .= '<h3>Before</h3>';
    $html .= '<div class="just-optimized-item wps-ic-before-container">';
    $html .= '<img src="' . $uncompress_sample_uri . '"/>';
    $html .= '<h4>' . size_format($compress_data['old']['size'], 2) . '</h4>';
    $html .= '</div>';
    $html .= '</div>';

    $html .= '<div class="third control-box">';
    $html .= '<h2 class="center">Sample.jpg</h2>';
    $html .= '<div class="just-optimized-item logo-bulk">';
    $html .= '<img src="' . WPS_IC_URI . 'assets/images/logo-bulk.png" alt="WP Compress"/>';
    $html .= '<h4>' . $current_save . '% Saved</h4>';
    $html .= '</div>';
    $html .= '</div>';

    $html .= '<div class="third">';
    $html .= '<h3>After</h3>';
    $html .= '<div class="just-optimized-item" wps-ic-after-container>';
    $html .= '<img src="' . $compress_sample_uri . '"/>';
    $html .= '<h4>' . size_format($compress_data['new']['size'], 2) . '</h4>';
    $html .= '</div>';
    $html .= '</div>';

    $html .= '<div class="clearfix"></div>';

    $html .= '<h5 class="green">Image details</h5>';

    $html .= '</div>';
    // Just Optimized Row ^

    /**
     * Restore Button
     */
    // Uncompressed
    $html .= '<div class="wps-ic-uncompressed">';
    $html .= '<img src="' . $logo_compressed . '" />';
    $html .= '<h5>' . $current_save . '%</h5>';
    $html .= '<h5>' . size_format($saved_bytes, 2) . '</h5>';
    $html .= '<h5>Saved</h5>';
    $html .= '</div>';

    //
    $html .= '<div class="wps-ic-media-actions">';
    $html .= '<div class="wps-ic-half-media-actions">';
    $html .= '<ul class="wps-ic-noncompressed-icon">';

    $html .= '<li class="wps-ic-weight"><span class="strike">' . size_format($compress_data['old']['size'], 2) . '</span></li>';
    $html .= '<li class="wps-ic-size"><span>' . $compress_data['new']['dimension'][0] . 'x' . $compress_data['new']['dimension'][1] . '</span></li>';

    $html .= '</ul>';
    $html .= '</div>';
    $html .= '<div class="wps-ic-half-media-actions">';
    $html .= '<ul class="wps-ic-noncompressed-icon">';
    $html .= '</li>';

    $html .= '<li class="wps-ic-size-compressed"><span>' . size_format($compress_data['new']['size'], 2) . '</span></li>';
    #$html .= '<li class="wps-ic-time"><span>' . (2+(rand(1, 5) / 10)) . 's</span></li>';

    $html .= '</ul>';
    $html .= '</div>';

    $html .= '<div class="wps-ic-media-actions-toolbox">';
    $html .= '<ul class="wps-ic-noncompressed-icon">';
    $html .= '<li class="wps-ic-action">';

    $html .= '<button type="button" class="btn btn-info wps-ic-restore-single-demo" style="padding-left:30px;padding-right:30px;">Restore</button>';

    $html .= '</li>';
    $html .= '</ul>';
    $html .= '</div>';

    $html .= '</div>';

    $html .= '<br/>';
    $html .= '<br/>';
    $html .= '<div>';
    $html .= '<h5 class="compress-info">Click restore to continue</h5>';
    $html .= '</div>';

    // wps_ic_sample_data
    #$html .= '</div>';

    $html .= '</div>';

    wp_send_json_success(array('html' => $html));
  }


  /**
   * Sample Image for Intro
   */
  public function wps_ic_sample() {
    global $wps_ic;

    $logo_compressed   = WPS_IC_URI . 'assets/images/compressed.png';
    $logo_uncompressed = WPS_IC_URI . 'assets/images/not-compressed.png';
    $logo_excluded     = WPS_IC_URI . 'assets/images/excluded.png';

    $html = '';

    // Loading
    $html .= '<div class="wps-ic-image-loading" id="wps-ic-sample-image-loading" style="display:none;">';
    $html .= '<img src="' . WPS_IC_URI . 'assets/images/spinner.svg" />';
    $html .= '<h5>Sit tight, we\'re compressing the image...</h5>';
    $html .= '</div>';


    $html .= '<div class="wps-ic-sample-data" id="wps-ic-sample-data">';

    $html .= '<div class="wps-ic-sample-compress">';
    $html .= '<h3>Let\'s get started!</h3>';
    $html .= '<p>Welcome to WP Compress, we want to make sure you\'re<br/>';
    $html .= 'all set up and in good hands!</p>';


    $compress_sample_dir = WPS_IC_DIR . 'assets/intro/assets/intro_b_noncompressed.jpg';
    $compress_sample_uri = WPS_IC_URI . 'assets/intro/assets/intro_b_noncompressed.jpg';

    // Not compressed
    $uncompressed_value_num = $uncompressed_value = filesize($compress_sample_dir);
    $uncompressed_value_num = $uncompressed_value_num / 1000;
    $uncompressed_value     = size_format($uncompressed_value, 2);
    $dimensions             = getimagesize($compress_sample_dir);
    $file_name              = basename($compress_sample_uri);

    // Image
    $html .= '<img src="' . $compress_sample_uri . '" id="wps-ic-sample-image" />';

    // wps-ic-uncompressed-data
    $html .= '<div class="wps-ic-uncompressed-data">';

    // Uncompressed
    $html .= '<div class="wps-ic-uncompressed">';
    $html .= '<img src="' . $logo_uncompressed . '" />';
    $html .= '<h5>Not Compressed</h5>';
    $html .= '</div>';

    // Actions
    $html .= '<div class="wps-ic-media-actions">';
    $html .= '<ul class="wps-ic-noncompressed-icon">';
    $html .= '<li class="wps-ic-weight">
				             <span>' . $uncompressed_value . '</span>
							</li>';
    $html .= '<li class="wps-ic-size">
				             <span>' . $dimensions[0] . 'x' . $dimensions[1] . '</span>
							</li>';
    $html .= '<li class="wps-ic-li-no-padding">';
    $html .= '<div class="wps-ic-media-actions-toolbox">';
    $html .= '<ul class="wps-ic-noncompressed-icon">';
    $html .= '<li class="wps-ic-action">';

    $html .= '<div class="btn-group">';
    $html .= '<button type="button" class="btn btn-success wps-ic-compress-single-demo" style="padding-left:30px;padding-right:30px;">Compress</button>';
    $html .= '</div>';
    $html .= '</li>';
    $html .= '</ul>';
    $html .= '</div>';

    $html .= '</li>';
    $html .= '</ul>';
    $html .= '</div>';

    // wps-ic-uncompressed-data
    $html .= '</div>';

    $html .= '<div>';
    $html .= '<h5 class="compress-info">To see how it works: Click compress to optimize the image</h5>';
    $html .= '</div>';

    // wps_ic_sample_data
    $html .= '</div>';

    $html .= '</div>';

    wp_send_json_success(array('html' => $html));
  }


}