<?php


/**
 * Class - Menu
 */
class wps_ic_menu extends wps_ic {

  public $templates;
  public static $slug;

  public function __construct() {

    $this::$slug = parent::$slug;

    if (is_admin()) {
      $this->templates = new wps_ic_templates();
      add_action('admin_menu', array($this, 'menu_init'));
    }

  }


  public function menu_init() {
    add_menu_page('WP Compress', 'WP Compress', 'manage_options', $this::$slug, array($this, 'render_admin_page'), WPS_IC_URI . 'assets/images/logo-menu.png');

    global $wps_ic,$wpdb;
    $response_key  = $wps_ic->options->get_option('response_key');

    $media = $wpdb->prepare("SELECT * FROM " . $wpdb->posts . " WHERE post_type=%s", 'attachment');
    $media = $wpdb->query($media);

   # if (!empty($response_key) && $media) {
      add_submenu_page('upload.php', 'Bulk Compress', 'Bulk Compress', 'manage_options', 'wp_compress_bulk', array($this, 'render_bulk_page'));
    #}
  }


  public function render_admin_page() {

    /**
     * Reset Debug Log
     */
    if (!empty($_GET['reset_debug_log'])) {
      global $wps_ic;
      $wps_ic->log->reset();
    }

    /**
     * View Debug Log
     */
    if (!empty($_GET['view_debug_log'])) {
      global $wps_ic;
      $wps_ic->log->view();
      die();
    }

    $this->templates->get_admin_page('main');
  }


  public function render_bulk_page() {
    $this->templates->get_admin_page('bulk');
  }


}